#ifndef __ARITHVECAPPLICATIVETEMPLATES_H
#define __ARITHVECAPPLICATIVETEMPLATES_H

namespace AVAT {

  template<class T>
    struct mul_assign {static inline void apply(T& t1,T t2){ t1 *= t2;}};
  
  template<class T>
    struct div_assign {static inline void apply(T& t1,T t2){ t1 /= t2;}};

  template<class T>
    struct sum_assign {static inline void apply(T& t1,T t2){ t1 += t2;}};
  
  template<class T>
    struct sub_assign {static inline void apply(T& t1,T t2){ t1 -= t2;}};

  template<class T>
    struct mul {static inline T apply(T t1,T t2){ return t1 * t2;}};
  
  template<class T>
    struct div {static inline T apply(T t1,T t2){ return t1 / t2;}};

  template<class T>
    struct add {static inline T apply(T t1,T t2){ return t1 + t2;}};

  template<class T>
    struct sub {static inline T apply(T t1,T t2){ return t1 - t2;}};

  template<class T>
    struct rel_eq {static inline bool apply(T t1, T t2){return t1 == t2;}};
  
  template<class T>
    struct rel_le {static inline bool apply(T t1, T t2){return t1 <= t2;}};

  template<class T>
    struct rel_ge {static inline bool apply(T t1, T t2){return t1 >= t2;}};

  template<class T>
    struct rel_l {static inline bool apply(T t1, T t2){return t1  <  t2;}};

  template<class T>
    struct rel_g {static inline bool apply(T t1, T t2){return t1  >  t2;}};

}

#endif
