#include "Vec3f.h"
#include "Vec3Hf.h"

Vec3f::Vec3f(const Vec3Hf& v)
{
  if(v[3] == 1.0)
    {
      (*this)[0] = v[0];
      (*this)[1] = v[1];
      (*this)[2] = v[2];
    }
  else
    {
      Vec3Hf tmp = v;
      tmp.de_homogenize();
      (*this)[0] = tmp[0];
      (*this)[1] = tmp[1];
      (*this)[2] = tmp[2];
    }
}

void Vec3f::get_spherical( float &theta, float &phi, float &rlen ) const
{  
  rlen = length();
  theta = acos((*this)[2]/rlen);    
  if ((*this)[0]>0)
    phi = atan((*this)[1]/(*this)[0]);
  else 
    if ((*this)[0]<0)
      phi = atan((*this)[1]/(*this)[0]) + M_PI;
    else 
      phi = ((*this)[1]>0) ? M_PI_2 : -1 * M_PI_2;
}


bool Vec3f::set_spherical( float theta, float phi, float rlen )
{
  if (theta > M_PI || theta <0)
    return false;
  (*this)[0] = rlen * sin(theta) * cos(phi);
  (*this)[1] = rlen * sin(theta) * sin(phi);
  (*this)[2] = rlen * cos(theta);
  return true;
}

