#ifndef __BITMAPRENDERCANVAS_H
#define __BITMAPRENDERCANVAS_H

#include <map.h>
#include <GL/gl.h>
#include <GL/glut.h>

#include "Common/CommonDefs.h"
#include "ColorVector.h"
#include "RenderCanvas.h"
#include "PPMBitmap.h"

/** A render canvas for bitmaps. I.e. rgb values with a byte per 
    value. 
 */
class BitmapRenderCanvas: public RenderCanvas, public PPMBitmap
{
public:
  
  /// Create a BitmapRenderCanvas of specified size
  BitmapRenderCanvas(int _w, int _h): RenderCanvas(_w,_h), PPMBitmap(_w,_h) {}
     
  /// 2D transform from window coordinates to image coordinates
  void window_coords2image_coords(float x, float y, 
                                  float& ipx, float& ipy) const
    {
      ipx = float(x-xw2)/float(get_x());
      ipy = float(y-yw2)/float(get_y());
    }

  /// Draw a pixel to the canvas.
  void draw_pixel(int x, int y, const ColorVector& cv)
    {
      set_pixel(x, y, cv);
    }
};

#endif


