#include "AbstractPlane.h"

bool AbstractPlane::intersection(Ray& r) const
{
  // dir must be normalized ! 
  float dnd;
  if ((dnd = n_dot(r.get_direction())) != 0)
    {
      r.set_parameter(-distance(r.get_origin()) / dnd);
      return true;
    }
  return false;
 }

bool AbstractPlane::intersection(Ray& r, float& dnd) const
{
  // dir must be normalized ! 
  if ((dnd = n_dot(r.get_direction())) != 0)
    {
      r.set_parameter(-distance(r.get_origin())/dnd);
      return true;
    }
  return false;
}

bool AbstractPlane::box_intersect(const Vec3f& c0, const Vec3f& c7) const
{
  bool above = false, below = false;
  for(int i=0;i<8;i++)
    {
      Vec3f c(i&1?c0[0]:c7[0], i&2?c0[1]:c7[1], i&4?c0[2]:c7[2]);
      
      if (distance(c) > 0)
        above = true;

      if (distance(c) < 0)
        below = true;

      if(above && below)
        return true;
    }
  return false;
}
