#ifndef __PLANE_H
#define __PLANE_H

#include "AbstractPlane.h"

/// The most generic plane class
class Plane: public AbstractPlane
{
  /// Plane normal
  Vec3f n;

	bool is_bounded;

	float bbox_side_len;

protected:
  
  /// Calculate dot product (the hard way)
  virtual float n_dot(const Vec3f& v) const
    {
      return dot(n,v);
    }

public:
  
  /// Plane default constructor
  Plane():is_bounded(false){};

  /// Plane defined by three points all lying in the plane
  Plane(const Vec3f&, const Vec3f&, const Vec3f&);

  /// Plane defined by a point and a normal
  Plane(const Vec3f&, const Vec3f&);

	/// Bounded plane.
	Plane(const Vec3f&, const Vec3f&, float);

  /// Return the normal
  Vec3f normal(const Vec3f& dummy) const {return n;}

	/// Bounding box
	bool bounding_box(Vec3f&,Vec3f&) const;
};


#endif 







